//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiMairie {

    /** Permet de récupérer l'ensemble des communes de la mairie */
    public enum GetApiMairieGetCommunes {

        public static let service = APIService<Response>(id: "getApiMairieGetCommunes", tag: "Api Mairie", method: "GET", path: "/apiMairie/getCommunes", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var codePostal: String

                public init(codePostal: String) {
                    self.codePostal = codePostal
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: GetApiMairieGetCommunes.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(codePostal: String) {
                let options = Options(codePostal: codePostal)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["codePostal"] = options.codePostal
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = [Commune]

            /** Succes */
            case status200([Commune])

            public var success: [Commune]? {
                switch self {
                case .status200(let response): return response
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
